
import java.applet.*;
import java.awt.*;
import java.awt.image.*;
import java.io.*;

public class
ImageArray extends Applet
{

  int pixels[];
  int XDim;
  int YDim;

  public
  ImageArray() {}

  public
  ImageArray(int _pixels[], int _XDim, int _YDim)
  {
     pixels = _pixels;
     XDim = _XDim;
     YDim = _YDim;

  }// end of Constructor()

  public int
  getXDim() { return XDim; }

  public int
  getYDim() { return YDim; }

  public Image
  getImage() 
  { return createImage(new MemoryImageSource(XDim,YDim,pixels,0,XDim)); }
 

  public int[]
  getPixels() { return pixels; }

  public static ImageArray
  getImageArray(Image img, ImageObserver observer) 
  { 
     ImageArray ret = null;

     int w = img.getWidth(observer);
     int h = img.getHeight(observer);

     while(w<1 || h<1)
     {
        w = img.getWidth(observer);
        h = img.getHeight(observer);
     }
     System.out.println(" Height : "+h);
     System.out.println(" Width : "+w);


     int mypixels[] = new int[w*h];

     PixelGrabber pg = new PixelGrabber(img,0,0,w,h,mypixels,0,w);

     try
     {
        pg.grabPixels();

     } catch(InterruptedException ie)
       { 
          System.out.println(" Error : "+ie);
          ie.printStackTrace();
          return ret; 
       }

     if((pg.status() & ImageObserver.ABORT) == 0) 
     {
         ret = new ImageArray(mypixels,w,h); 
         System.out.println(" I defined  ");
     }
     else
          System.out.println(" Cannot Grab : ");

     return ret;

  }// end of getImageArray()

  public void
  dump(OutputStream ou) 
  { 

     //PrintWriter out = new PrintWriter(ou);

     System.out.println(" in Dump : ");
     System.out.println(" Height : "+getYDim());
     System.out.println(" Width : "+getXDim());
  }

}// end of ImageArray
